<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { ref } from 'vue';
import { useFloating, autoUpdate, offset, flip, inline } from '@floating-ui/vue';

const props = defineProps({
    tooltip: String
});

const emits = defineEmits<{
    (e: 'click'):void
}>();
 
const show = ref(false);
const reference = ref(null);
const floating = ref(null);
const { floatingStyles } = useFloating(reference, floating ,{
    whileElementsMounted: autoUpdate,
    middleware: [offset(5),flip(), inline()]
});

const clickHandler = ()=>{
    emits('click');
}

const toggleShow = ()=>{
    show.value = !show.value;
}
</script>
 
<template>
    <div class="uk-margin-small-top uk-margin-small-bottom justify-center" ref="reference" @mouseenter="toggleShow" @mouseleave="toggleShow" @click="clickHandler">
        <slot></slot>
    </div>
  <div class="tooltip" ref="floating" :style="floatingStyles" v-if="show">{{ tooltip }}</div>
</template>
<style scoped>
.tooltip{
    width: fit-content;
    height:20px;
    background: #666;
    color:white;
    font-size: 12px;
    line-height: 20px;
    vertical-align: middle;
    border-radius: 2px;
    padding-left: 5px;
    padding-right: 5px;
}

.justify-center{
    display: flex;
    justify-content: center;
    padding-left:0px!important;
}
</style>